vfDraw = {};

function vfDraw:setFillLevelsDisplay(display)
	setTextAlignment(0);		
	setTextColor(unpack(g_currentMission.hl.getColor(VehicleFruitHud.values.txtColor, true)));
	setTextBold(VehicleFruitHud.values.txtBold);	
	local frameHeight = display.frameHeight;
	local int = 0;
	for a=1, #display.fillLevelBuffer do
		if display.fillLevelBuffer[a] ~= nil then
			local capacity = display.fillLevelBuffer[a].capacity or 0;
			local fillLevel = display.fillLevelBuffer[a].fillLevel or 0;
			local txtHeight = getTextHeight(display.fillLevelTextSize, tostring("Äg"));					
			local fillType = display.fillLevelBuffer[a].fillType or 0;						
			local descFill = g_currentMission.fillTypeManager.fillTypes[fillType];						
			local difHeight = VehicleFruitHud.values.difTxt.height/1000;
			local difAlignment = VehicleFruitHud.values.difTxt.alignment/1000;
			local difTxtSize = VehicleFruitHud.values.difTxt.size/1000;			
			local isBestPrice = false;
			local renderCBtxt = "";
			if descFill ~= nil then						
				local frame = display.fillTypeFrames[fillType];
				if frame:getVisible() then							
					local posX, posY = frame:getPosition();
					local width = frame:getWidth();
					int = int+1;
					local name = descFill.title or descFill.name;							
					if fillLevel > 0 and VehicleFruitHud.values.viewFillName and not string.find(name, "Unknown") then
						setTextAlignment(2);
						if int == 1 then
							renderText(display.origX+display.firstFillTypeOffset, posY, display.fillLevelTextSize+(difTxtSize), tostring(name));
						else
							renderText(display.origX, posY, display.fillLevelTextSize, tostring(name));
						end;								
					end;
					if fillLevel > 0 and VehicleFruitHud.values.viewBestPrice.isOn and not string.find(name, "Unknown") then
						isBestPrice = vfSetGetForMoh:getBestPrice(fillType);
						if isBestPrice and VehicleFruitHud.values.viewBestPrice.bestPrice > 0 then
							renderCBtxt = tostring(g_i18n:formatMoney(fillLevel/1000*VehicleFruitHud.values.viewBestPrice.bestPrice, 0, true, false));
						else
							isBestPrice = false;
						end;
					end;
					if capacity > 0 and VehicleFruitHud.values.viewCapacityTotal then 
						if isBestPrice then 
							renderCBtxt = tostring(capacity).. " / ".. renderCBtxt;
						else
							renderCBtxt = tostring(capacity);
						end;
					end;
					if string.len(renderCBtxt) > 0 then
						setTextAlignment(0);
						renderText(display.origX+(width/3)+(difAlignment), posY-txtHeight+(display.frameOffsetY/2)+(difHeight), display.fillLevelTextSize+(difTxtSize), tostring(renderCBtxt));
					end;					
				end;
			end;					
		end;				
	end;
end;

function vfDraw:setOpen(vehicle, speed)
	if VehicleFruitHud.values.horseHud == nil then return;end;	
	vfSetGet:clearBox(VehicleFruitHud.values.horseHud);				
	vfDraw:showInfo(vehicle.spec_rideable, VehicleFruitHud.values.horseHud, speed);	
	vfDraw:draw(VehicleFruitHud.values.horseHud, 0.99, 0.01);
	VehicleFruitHud.values.horseHud.doShowNextFrame = false;
end;

function vfDraw:showInfo(vehicle, box, speed)	
	vfDraw:addInfos(vehicle, box, speed);
	vfSetGet:addBoxLine(box, g_i18n:getText("infohud_name"), vehicle.cluster.name);	
	vfSetGet:addBoxLine(box, box.cluster.infoSellPrice.title, box.cluster.infoSellPrice.text, box.cluster.infoSellPrice.otherColor);	
	vfSetGet:addBoxLine(box, box.cluster.infoSpeed.title, box.cluster.infoSpeed.text);	
	vfSetGet:addBoxLine(box, box.cluster.infoTyp.title, box.cluster.infoTyp.text);	
	vfSetGet:addBoxLine(box, box.cluster.infoAge.title, box.cluster.infoAge.text);
	vfSetGet:addBoxLine(box, box.cluster.infoHealth.title, box.cluster.infoHealth.text);
	if box.cluster.infoReproduction.active then
		vfSetGet:addBoxLine(box, box.cluster.infoReproduction.title, box.cluster.infoReproduction.text);
	end;
	if box.cluster.infoReproductionMinAge.active then
		vfSetGet:addBoxLine(box, box.cluster.infoReproductionMinAge.title, box.cluster.infoReproductionMinAge.text);
	end;
	vfSetGet:addBoxLine(box, box.cluster.infoRiding.title, box.cluster.infoRiding.text);
	vfSetGet:addBoxLine(box, box.cluster.infoFitness.title, box.cluster.infoFitness.text);
	vfSetGet:addBoxLine(box, box.cluster.infoCleanliness.title, box.cluster.infoCleanliness.text);	
end;

function vfDraw:addInfos(vehicle, box, speed)	
	local visual = g_currentMission.animalSystem:getVisualByAge(vehicle.cluster.subTypeIndex, vehicle.cluster.age);	
	box.cluster.infoSpeed.text = tostring(speed);
	box.cluster.infoAge.text = g_i18n:formatNumMonth(vehicle.cluster.age);
	box.cluster.infoTyp.text = tostring(visual.store.name);	
	
	local cleanlinessFactor = 1 - vehicle.cluster.dirt/100;
	box.cluster.infoCleanliness.value = cleanlinessFactor;
	box.cluster.infoCleanliness.ratio = cleanlinessFactor;
	box.cluster.infoCleanliness.text = string.format("%d %%", g_i18n:formatNumber(cleanlinessFactor * 100, 0));

	local fitnessFactor = vehicle.cluster.fitness/100;
	box.cluster.infoFitness.value = fitnessFactor;
	box.cluster.infoFitness.ratio = fitnessFactor;
	box.cluster.infoFitness.text = string.format("%d %%", g_i18n:formatNumber(fitnessFactor * 100, 0));

	local ridingFactor = vehicle.cluster.riding/100;
	box.cluster.infoRiding.value = ridingFactor;
	box.cluster.infoRiding.ratio = ridingFactor;
	box.cluster.infoRiding.text = string.format("%d %%", g_i18n:formatNumber(ridingFactor * 100, 0));
	
	local healthFactor = vehicle.cluster.health/100;
	box.cluster.infoHealth.value = healthFactor;
	box.cluster.infoHealth.ratio = healthFactor;
	box.cluster.infoHealth.text = string.format("%d %%", g_i18n:formatNumber(healthFactor * 100, 0));
	
	box.cluster.infoSellPrice.text =  g_i18n:formatMoney(vfSetGet:getSellPrice(vehicle, healthFactor, fitnessFactor), 0, true, true);
	box.cluster.infoSellPrice.otherColor = g_currentMission.hl.getColor("ls22", true);
	
	if vfSetGet:getSupportsReproduction(vehicle) then
		local subType = g_currentMission.animalSystem:getSubTypeByIndex(vehicle.cluster.subTypeIndex);
		if vehicle.cluster.age < subType.reproductionMinAgeMonth then
			local minAgeFactor = MathUtil.clamp(vehicle.cluster.age / subType.reproductionMinAgeMonth, 0, 1);
			box.cluster.infoReproductionMinAge.value = minAgeFactor;
			box.cluster.infoReproductionMinAge.ratio = minAgeFactor;
			box.cluster.infoReproductionMinAge.text = string.format("%d %%", g_i18n:formatNumber(minAgeFactor * 100, 0));
			box.cluster.infoReproductionMinAge.active = true;
		else
			local reproductionFactor = vehicle.cluster.reproduction/100;
			box.cluster.infoReproduction.value = reproductionFactor;
			box.cluster.infoReproduction.ratio = reproductionFactor;
			box.cluster.infoReproduction.text = string.format("%d %%", g_i18n:formatNumber(reproductionFactor * 100, 0));
			box.cluster.infoReproduction.disabled = not vfSetGet:getCanReproduce(vehicle, healthFactor);
			box.cluster.infoReproduction.active = true;
		end;
	else
		box.cluster.infoReproductionMinAge.active = false;
		box.cluster.infoReproduction.active = false;
	end;
end;

function vfDraw:draw(box, posX, posY)
	local rightX = posX;
	local leftX = posX - box.boxWidth;
	local y = posY;
	local height = 2 * box.listMarginHeight + #box.activeLines * box.rowHeight;
	drawFilledRect(leftX, y, box.boxWidth, height, 0, 0, 0, 0.75);
	setTextAlignment(RenderText.ALIGN_LEFT);
	setTextColor(unpack(VehicleFruitHud.boxColor.TEXT_DEFAULT));
	setTextBold(true);
	renderText(leftX + box.labelTextOffsetX, y + height + box.labelTextOffsetY, box.titleTextSize, box.title);
	setTextBold(false);
	y = y + box.listMarginHeight;
	leftX = leftX + box.leftTextOffsetX + box.listMarginWidth;
	rightX = rightX - box.rightTextOffsetX - box.listMarginWidth;
	local textAreaX = box.boxWidth - box.leftTextOffsetX - box.listMarginWidth - box.rightTextOffsetX - box.listMarginWidth;
	for i = #box.activeLines, 1, -1 do
		local line = box.activeLines[i];
		setTextBold(true);
		if line.otherColor then
			setTextColor(unpack(line.otherColor or VehicleFruitHud.boxColor.TEXT_HIGHLIGHT));
		end;
		setTextAlignment(RenderText.ALIGN_LEFT);
		renderText(leftX, y + box.leftTextOffsetY, box.rowTextSize, line.key);
		setTextAlignment(RenderText.ALIGN_RIGHT);
		local maxWidth = textAreaX - 0.025 * box.boxWidth - getTextWidth(box.rowTextSize, line.key);
		setTextBold(false);
		local text = Utils.limitTextToWidth(line.value, box.rowTextSize, maxWidth, false, "...");
		renderText(rightX, y + box.rightTextOffsetY, box.rowTextSize, text);
		if line.otherColor then
			setTextColor(unpack(VehicleFruitHud.boxColor.TEXT_DEFAULT));
		end;
		if i < #box.activeLines then
			drawFilledRect(leftX, y, box.rowWidth, 1 / g_screenHeight, unpack(VehicleFruitHud.boxColor.SEPARATOR));
		end;
		y = y + box.rowHeight;
	end;
	setTextAlignment(RenderText.ALIGN_LEFT);
	box.doShowNextFrame = false;
end;
